
CC = gcc
CXX = g++
CCFLAGS = -g -W -Wall 

FLEX = flex
FLEX_OPTS = -PInstant

BISON = bison
BISON_OPTS = -t -pInstant

OBJS_LLVM = llvm.o llvm_blocks.o llvm_const.o
OBJS_JVM = jvm.o jvm_blocks.o jvm_const.o

OBJS = Absyn.o Lexer.o Parser.o Printer.o env.o 

.PHONY: clean distclean TAR_LLVM TAR_JVM

all: insc_llvm insc_jvm

clean:
	rm -f *.o TestInstant MainInstant Instant.aux Instant.log Instant.pdf Instant.dvi Instant.ps Instant

distclean: clean
	rm -f Absyn.h Absyn.c Test.c Parser.c Parser.h Lexer.c Skeleton.c Skeleton.h Printer.c Printer.h Makefile Instant.l Instant.y Instant.tex 

insc_jvm: TAR_JVM ${OBJS} ${OBJS_JVM} main-jvm.o
	@echo "Linking insc_jvm..."
	${CXX} ${CCFLAGS} ${OBJS} ${OBJS_JVM} main-jvm.o -o $@

insc_llvm: TAR_LLVM ${OBJS} ${OBJS_LLVM} main-llvm.o
	@echo "Linking insc_llvm..."
	${CXX} ${CCFLAGS} ${OBJS} ${OBJS_LLVM} main-llvm.o -o $@

TAR_LLVM:
	$(eval TARGET = 1)

TAR_JVM:
	$(eval TARGET = 0)

Absyn.o: Absyn.c Absyn.h
	${CC} ${CCFLAGS} -c Absyn.c

Lexer.c: Instant.l
	${FLEX} ${FLEX_OPTS} -oLexer.c Instant.l

Parser.c: Instant.y
	${BISON} ${BISON_OPTS} Instant.y -o Parser.c

Lexer.o: Lexer.c Parser.h
	${CC} ${CCFLAGS} -c Lexer.c 

Parser.o: Parser.c Absyn.h
	${CC} ${CCFLAGS} -c Parser.c

Printer.o: Printer.c Printer.h Absyn.h
	${CC} ${CCFLAGS} -c Printer.c

main-jvm.o: main.c Parser.h Printer.h Absyn.h
	${CC} ${CCFLAGS} -DTARGET=$(TARGET) -c main.c -o $@

main-llvm.o: main.c Parser.h Printer.h Absyn.h
	${CC} ${CCFLAGS} -DTARGET=$(TARGET) -c main.c -o $@

%.o: %.c
	${CC} ${CCFLAGS} -DTARGET=$(TARGET) -c $<

